window.MultipleChoiceTestData = {
    // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
    "maxTries": Infinity,

    // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
    "reportScore": false,

    // Optional: Sollen die Fragen nicht durchgemischt werden?
    "keepOrder": false,

    // Optional: Wie soll bewertet werden?
    // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
    // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
    // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
    "countMode": "questions",

    // Wie viele Fragen sollen für einen Test gezogen werden?
    "questionsPerTest": 5,

    // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
    "threshold": 1,

    // Optional: Begrüßungstext
    "htmlIntro": "<p>Ergänze die fehlenden Variablenwerte, um dieses Lernpaket erfolgreich abzuschließen.</p>",

    // Verfügbare Fragen
    "questions": [],

    // Fragengeneratoren
    "generators": []
};

(function(generators) {
    function negativEingeklammert(v) {
        if (v >= 0)
            return v;
        return '(' + v + ')';
    }

    function addLinearFactor(x0, forcePlus) {
        if (forcePlus) {
            let s = (x0 < 0) ? '[' : '(';
            s += 'x + ';
            s += (x0 < 0) ? '(' : '';
            s += "<strong style=\"background-color:#fce94f\">";
            s += x0;
            s += "</strong>";
            s += (x0 < 0) ? ')]' : ')';
            return s;
        }
        if (x0 == 0)
            return 'x';
        return '(x ' + ((x0 < 0) ? '- ' : '+ ') + Math.abs(x0) + ')';
    }

    const arrUsed = [];

    function addFrage(arrFragen, x1, x2) {
        const maxNumber = 5;
        let raw_x1 = x1 * (1 + Math.floor(Math.random() * maxNumber));
        let raw_x2 = x2 * (1 + Math.floor(Math.random() * maxNumber));
        while (true) {
            const signature = Math.min(raw_x1, raw_x2) + ',' + Math.max(raw_x1, raw_x2);
            if (arrUsed.indexOf(signature) != -1) {
                raw_x1 = x1 * (Math.abs(raw_x1) + 1);
                if (Math.abs(raw_x1) > maxNumber) {
                    raw_x1 = x1;
                    raw_x2 = x2 * (Math.abs(raw_x2) + 1);
                    if (Math.abs(raw_x2) > maxNumber)
                        raw_x2 = x2;
                }
                continue;
            }
            arrUsed.push(signature);
            x1 = Math.min(raw_x1, raw_x2);
            x2 = Math.max(raw_x1, raw_x2);
            break;
        }
        const gemischt = x1 + x2;
        const konstant = x1 * x2;
        const frage = {
            "html": "???",
            "response": "",
            "keepOrder": true,
            "choices": [
                { "html": "Kleinere Zahl <code>u</code>: ", "min": -10, "max": 10, "step": 1, "type": "number", "size": 2, "correct": true, "accept": x1, "response": "", "selectalways": true },
                { "html": "Größere Zahl <code>v</code>: ", "min": -10, "max": 10, "step": 1, "type": "number", "size": 2, "correct": true, "accept": x2, "response": "", "selectalways": true }
            ]
        };
        let term = 'x² ';
        if (gemischt != 0) {
            term += (gemischt < 0) ? '- ' : '+ ';
            if (Math.abs(gemischt) != 1)
                term += Math.abs(gemischt);
            term += 'x';
        }
        if (konstant != 0) {
            term += (konstant < 0) ? ' - ' : ' + ';
            term += Math.abs(konstant);
        }

        frage.html = "<p>Ergänze die Werte <code>u</code> (kleinere Zahl) und <code>v</code> (größere Zahl) in <code>f(x) = " + term + " = (x + u)(x + v)</code>?</p>";
        frage.response = "<code>f(x) = " + term + " = " + addLinearFactor(x1, true) + ' · ' + addLinearFactor(x2, true) + '</code>, weil <code>' + konstant + ' = ' + negativEingeklammert(x1) + ' · ' + negativEingeklammert(x2) + '</code> und <code>' + gemischt + ' = ' + x1 + ' + ' + negativEingeklammert(x2) + '</code>';
        frage.htmlSolution = "<p><code>f(x) = " + term + " = x² + <strong style=\"background-color:#fce94f\">" + negativEingeklammert(gemischt) + "</strong>· x + <strong style=\"background-color:#fce94f\">" + negativEingeklammert(konstant) + "</strong> = (x + u)(x + v)</code>?</p>";
        arrFragen.push(frage);
    }

    [-1, +1].map(y_S => [-1, +1].map(x_S => [0, 1, 2, 3, 4].map(a => generators.push(arrFragen => addFrage(arrFragen, x_S,  y_S)))));
    generators.push(arrFragen => addFrage(arrFragen, 0, 0));
    generators.push(arrFragen => addFrage(arrFragen, 0, -1));
    generators.push(arrFragen => addFrage(arrFragen, 0, 1));
})(window.MultipleChoiceTestData.generators);
